#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct Leader *Lref; // :    .
typedef struct Trailer *Tref; // :    .

//   .
typedef struct Leader 
{ 
  int Key;   //  .
  int Count; // .
  int WGN;   // .
  Tref Trail;//   .
  Lref Next; //       .
};

//   .
typedef struct Trailer 
{ 
  Lref Id; 
  Tref Next; 
};

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    Lref Stack[30]; // .
    void SearchGraph (int, Lref *);
    void Cycle (Lref, int *, int *);
  public:
    Spisok() {//   .
              Head = Tail =  new (Leader); }
    void MakeGraph ();
    void PrintGraph ();
    void Mn_Cycle();
};

void main ()
{
  Spisok A;

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //    .
  A.Mn_Cycle();
}

void Spisok::Mn_Cycle()
//     G.
{
  cout << " :\n ";
  int num = 0, d = 0; //   .
  Stack[0] = NULL;
  Lref t = Head;
  while ( t!=Tail )
  {  t->WGN = 0; t = t->Next; }
  t = Head;
  while ( t!=Tail )
  {
     if ( t->WGN==0 ) Cycle(t,&d,&num);
     t = t->Next;
  }
}

void Spisok::Cycle (Lref r, int *d, int *num)
//    
// ,   r->Key.
{
  Tref t;
  int i;

  (*d)++; Stack[(*d)] = r;
  (*num)++; r->WGN = *num;
  t = r->Trail;
  while ( t != NULL )
  {
    if ( t->Id->WGN==0 ) Cycle (t->Id,d,num);
    else  
       if  (t->Id->Key != Stack[(*d)-1]->Key &&
            r->WGN > t->Id->WGN)
       {
          i = *d;
          while ( Stack[i]->Key != t->Id->Key )
          {
             cout << Stack[i]->Key << " ";
             i--;
          }
          cout << t->Id->Key << endl;
       }
    t = t->Next;
  }
  //   r->Key   .
  (*d)--;
}

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (Trailer); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<<"("<<(*p).Key; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}
